//+------------------------------------------------------------------+
//|                                               ePosProfitTest.mq5 |
//|              Copyright Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
int Magic_N=20;
string Symbol_1="EURUSD";
string Symbol_2="GBPUSD";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class PositionProfit
  {
private:
   string            pSymbol;
   int               pMagic;
   bool              pFirstStart;
   ulong             pLastTicket;
   double            pProfit;
   datetime          pLoadHistoryFrom;
   double            SymbolProfit();
public:
   void Init(string aSymbol,int aMagic)
     {
      pSymbol=aSymbol;
      pMagic=aMagic;
      pFirstStart=false;
      pLastTicket=0;
      pProfit=0;
     }
   bool              GetProfit(double  &aProfit);
  };

PositionProfit PosPrl11;
PositionProfit PosPrl12;
PositionProfit PosPrl21;
PositionProfit PosPrl22;

int s1r1;
int s1r2;
int s2r1;
int s2r2;

MqlTradeRequest request;
MqlTradeResult result;

double RPrl11=0,RPrl12=0,RPrl21=0,RPrl22=0;

string gvp;
string Commom_gvp;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   s1r1=iRSI(Symbol_1,TimeFrame,14,PRICE_CLOSE);
   s1r2=iRSI(Symbol_1,TimeFrame,21,PRICE_CLOSE);
   s2r1=iRSI(Symbol_2,TimeFrame,14,PRICE_CLOSE);
   s2r2=iRSI(Symbol_2,TimeFrame,21,PRICE_CLOSE);
   fCreateGVP();
   fDeleteGV();
   PosPrl11.Init(Symbol_1,1);
   PosPrl12.Init(Symbol_1,2);
   PosPrl21.Init(Symbol_2,1);
   PosPrl22.Init(Symbol_2,2);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   IndicatorRelease(s1r1);
   IndicatorRelease(s1r2);
   IndicatorRelease(s2r1);
   IndicatorRelease(s2r2);
   fDeleteGV();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   datetime TimeNow_1[1];
   datetime TimeNow_2[1];
   static datetime LastTime_1=0;
   static datetime LastTime_2=0;
   if(CopyTime(Symbol_1,TimeFrame,1,1,TimeNow_1)==-1)return;
   if(CopyTime(Symbol_2,TimeFrame,1,1,TimeNow_2)==-1)return;
   if(LastTime_1==0)LastTime_1=TimeNow_1[0];
   if(LastTime_2==0)LastTime_2=TimeNow_2[0];
   if(LastTime_1!=TimeNow_1[0])
     {
      double ind1[2];
      double ind2[2];
      CopyBuffer(s1r1,0,1,2,ind1);
      CopyBuffer(s1r2,0,1,2,ind2);
      if(ind1[1]>30 && ind1[0]<=30)
        {
         AlertAboutProfit(" ");
         fOpBuy(Symbol_1,0.1,0,1,""," buy ( - 1,  - 1)");
         RPrl11+=0.1;
         AlertAboutProfit(" ");
        }
      if(ind1[1]<70 && ind1[0]>=70)
        {
         AlertAboutProfit(" ");
         fOpSell(Symbol_1,0.1,0,1,""," sell ( - 1,  - 1)");
         RPrl11-=0.1;
         AlertAboutProfit(" ");
        }

      if(ind2[1]>30 && ind2[0]<=30)
        {
         AlertAboutProfit(" ");
         fOpBuy(Symbol_1,0.2,0,2,""," buy ( - 1,  - 2)");
         RPrl12+=0.2;
         AlertAboutProfit(" ");
        }
      if(ind2[1]<70 && ind2[0]>=70)
        {
         AlertAboutProfit(" ");
         fOpSell(Symbol_1,0.2,0,2,""," sell ( - 1,  - 2)");
         RPrl12-=0.2;
         AlertAboutProfit(" ");
        }
      LastTime_1=TimeNow_1[0];
     }

   if(LastTime_2!=TimeNow_2[0])
     {
      double ind1[2];
      double ind2[2];
      CopyBuffer(s2r1,0,1,2,ind1);
      CopyBuffer(s2r2,0,1,2,ind2);
      if(ind1[1]>30 && ind1[0]<=30)
        {
         AlertAboutProfit(" ");
         if(fOpBuy(Symbol_2,0.1,0,1,""," buy ( - 2,  - 1)"))
           {
            RPrl21+=0.1;
            AlertAboutProfit(" ");
           }
        }
      if(ind1[1]<70 && ind1[0]>=70)
        {
         AlertAboutProfit(" ");
         if(fOpSell(Symbol_2,0.1,0,1,""," sell ( - 2,  - 1)"))
           {
            RPrl21-=0.1;
            AlertAboutProfit(" ");
           }
        }

      if(ind2[1]>30 && ind2[0]<=30)
        {
         AlertAboutProfit(" ");
         if(fOpBuy(Symbol_2,0.2,0,2,""," buy ( - 2,  - 2)"))
           {
            RPrl22+=0.2;
            AlertAboutProfit(" ");
           }
        }
      if(ind2[1]<70 && ind2[0]>=70)
        {
         AlertAboutProfit(" ");
         if(fOpSell(Symbol_2,0.2,0,2,""," sell ( - 2,  - 2)"))
           {
            RPrl22-=0.2;
            AlertAboutProfit(" ");
           }
        }
      LastTime_2=TimeNow_2[0];
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AlertAboutProfit(string aMessage)
  {
   double Prl11;
   double Prl12;
   double Prl21;
   double Prl22;
   PosPrl11.GetProfit(Prl11);
   PosPrl12.GetProfit(Prl12);
   PosPrl21.GetProfit(Prl21);
   PosPrl22.GetProfit(Prl22);
   Alert("");
   Alert(aMessage);
   Alert("    . 11: "+DS2(Prl11)+"("+DS2(RPrl11)+"), 12: "+DS2(Prl12)+"("+DS2(RPrl12)+"), 21: "+DS2(Prl21)+"("+DS2(RPrl21)+"), 22: "+DS2(Prl22)+"("+DS2(RPrl22)+")");
   if(ND2(Prl11-RPrl11)!=0 || ND2(Prl12-RPrl12)!=0 || ND2(Prl21-RPrl21)!=0 || ND2(Prl22-RPrl22)!=0)
     {
      Alert("!!! ERROR !!! ERROR !!! ERROR !!!");
     }
   Alert("");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string DS2(double aValue)
  {
   return(DoubleToString(aValue,2));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ND2(double aValue)
  {
   return(NormalizeDouble(aValue,2));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool fOpBuy(string aSymbol,double aProfit,int aSlippage=0,int aMagic=0,string aComment="",string aMessage="",bool aSound=false)
  {
   request.symbol=aSymbol;
   request.action=TRADE_ACTION_DEAL;
   request.type=ORDER_TYPE_BUY;
   //request.Profit=aProfit;
   request.price=SymbolInfoDouble(aSymbol,SYMBOL_ASK);
   request.sl=0;
   request.tp=0;
   request.deviation=aSlippage;
   request.type_filling=ORDER_FILLING_AON;
   request.comment=aComment;
   request.magic=aMagic;
   if(aMessage!="")Alert(aMessage);
   if(aSound)PlaySound("expert");
   OrderSend(request,result);
   if(result.retcode==TRADE_RETCODE_DONE)
     {
      Alert("... (#"+IntegerToString(result.order)+")");
      if(aSound)PlaySound("ok");
      return(true);
     }
   else
     {
      Alert("... "+IntegerToString(result.retcode)+" - "+fTradeRetCode(result.retcode));
      if(aSound)PlaySound("timeout");
      return(false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool fOpSell(string aSymbol,double aProfit,int aSlippage=0,int aMagic=0,string aComment="",string aMessage="",bool aSound=false)
  {
   request.symbol=aSymbol;
   request.action=TRADE_ACTION_DEAL;
   request.type=ORDER_TYPE_SELL;
   //request.Profit=aProfit;
   request.price=SymbolInfoDouble(aSymbol,SYMBOL_BID);
   request.sl=0;
   request.tp=0;
   request.deviation=aSlippage;
   request.type_filling=ORDER_FILLING_AON;
   request.comment=aComment;
   request.magic=aMagic;
   if(aMessage!="")Alert(aMessage);
   if(aSound)PlaySound("expert");
   OrderSend(request,result);
   if(result.retcode==TRADE_RETCODE_DONE)
     {
      Alert("... (#"+IntegerToString(result.order)+")");
      if(aSound)PlaySound("ok");
      return(1);
     }
   else
     {
      Alert("... "+IntegerToString(result.retcode)+" - "+fTradeRetCode(result.retcode));
      if(aSound)PlaySound("timeout");
      return(-1);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string fTradeRetCode(int aRetCode)
  {
   string tErrText="  ("+IntegerToString(aRetCode)+")";
   switch(aRetCode)
     {
      case TRADE_RETCODE_REQUOTE:            return(" (REQUOTE)");
      case TRADE_RETCODE_REJECT:             return("  (REJECT)");
      case TRADE_RETCODE_CANCEL:             return("   (CANCEL)");
      case TRADE_RETCODE_PLACED:             return("  (PLACED)");
      case TRADE_RETCODE_DONE:               return("  (DONE)");
      case TRADE_RETCODE_DONE_PARTIAL:       return("   (DONE_PARTIAL)");
      case TRADE_RETCODE_ERROR:              return("   (ERROR)");
      case TRADE_RETCODE_TIMEOUT:            return("     (TIMEOUT)");
      case TRADE_RETCODE_INVALID:            return("  (INVALID)");
      case TRADE_RETCODE_INVALID_VOLUME:     return("    (INVALID_VOLUME)");
      case TRADE_RETCODE_INVALID_PRICE:      return("    (INVALID_PRICE)");
      case TRADE_RETCODE_INVALID_STOPS:      return("    (INVALID_STOPS)");
      case TRADE_RETCODE_TRADE_DISABLED:     return("  (TRADE_DISABLED)");
      case TRADE_RETCODE_MARKET_CLOSED:      return("  (MARKET_CLOSED)");
      case TRADE_RETCODE_NO_MONEY:           return("       (NO_MONEY)");
      case TRADE_RETCODE_PRICE_CHANGED:      return("  (PRICE_CHANGED)");
      case TRADE_RETCODE_PRICE_OFF:          return("     (PRICE_OFF)");
      case TRADE_RETCODE_INVALID_EXPIRATION: return("      (INVALID_EXPIRATION)");
      case TRADE_RETCODE_ORDER_CHANGED:      return("   (ORDER_CHANGED)");
      case TRADE_RETCODE_TOO_MANY_REQUESTS:  return("   (TOO_MANY_REQUESTS)");
      case TRADE_RETCODE_NO_CHANGES:         return("    (NO_CHANGES)");
      case TRADE_RETCODE_SERVER_DISABLES_AT: return("   (SERVER_DISABLES_AT)");
      case TRADE_RETCODE_CLIENT_DISABLES_AT: return("    (CLIENT_DISABLES_AT)");
      case TRADE_RETCODE_LOCKED:             return("    (LOCKED)");
      case TRADE_RETCODE_FROZEN:             return("    (FROZEN)");
      case TRADE_RETCODE_INVALID_FILL:       return("       (INVALID_FILL)");
      case TRADE_RETCODE_CONNECTION: return("     (REQUEST_CONNECTION)");
     }
   return("???");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void fCreateGVP()
  {
   gvp=MQL5InfoString(MQL5_PROGRAM_NAME)+"_"+_Symbol+"_"+IntegerToString(Magic_N)+"_";
   Commom_gvp="COMMOM_";
   if(AccountInfoInteger(ACCOUNT_TRADE_MODE)==ACCOUNT_TRADE_MODE_DEMO)
     {
      gvp=gvp+"d_";
     }
   if(AccountInfoInteger(ACCOUNT_TRADE_MODE)==ACCOUNT_TRADE_MODE_REAL)
     {
      gvp=gvp+"r_";
     }
   if(MQL5InfoInteger(MQL5_TESTING))
     {
      gvp=gvp+"t_";
      Commom_gvp=gvp;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void fDeleteGV()
  {
   if(MQL5InfoInteger(MQL5_TESTING))
     {
      for(int i=GlobalVariablesTotal()-1;i>=0;i--)
        {
         if(StringFind(GlobalVariableName(i),gvp,0)==0)
           {
            GlobalVariableDel(GlobalVariableName(i));
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void fGVS(string aName,double aValue)
  {
   GlobalVariableSet(gvp+aName,aValue);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double fGVG(string aName)
  {
   return(GlobalVariableGet(gvp+aName));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void fGVD(string aName)
  {
   GlobalVariableDel(gvp+aName);
  }
//+------------------------------------------------------------------+

double PositionProfit::SymbolProfit()
  {
   double TmpLots=0;
   for(int i=0;i<PositionsTotal();i++)
     {
      if(PositionGetSymbol(i)==pSymbol)
        {
         TmpLots=PositionGetDouble(POSITION_PROFIT);
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            TmpLots*=1;
           }
         break;
        }
     }
   TmpLots=NormalizeDouble(TmpLots,2);
   return(TmpLots);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool PositionProfit::GetProfit(double  &aProfit)
  {
   if(!pFirstStart)
     {
      if(GlobalVariableCheck(Commom_gvp+pSymbol+"_HistStTm"))
        {
         pLoadHistoryFrom=(datetime)GlobalVariableGet(Commom_gvp+pSymbol+"_HistStTm");
        }
      else
        {
         GlobalVariableSet(Commom_gvp+pSymbol+"_HistStTm",0);
        }
      if(!HistorySelect(pLoadHistoryFrom,TimeCurrent()))
        {
         return(false);
        }
      double CurrentProfit=SymbolProfit();
      double Sum=0;
      int FromI=0;
      int FromTicket=0;
      for(int i=HistoryDealsTotal()-1;i>=0;i--)
        {
         ulong ticket=HistoryDealGetTicket(i);
         if(ticket!=0)
           {
            switch(HistoryDealGetInteger(ticket,DEAL_TYPE))
              {
               case DEAL_TYPE_BUY:
                  Sum=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                  Sum=NormalizeDouble(Sum,2);
                  break;
               case DEAL_TYPE_SELL:
                  Sum=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                  Sum=NormalizeDouble(Sum,2);
                  break;
              }
            if(CurrentProfit==Sum)
              {
               pLoadHistoryFrom=HistoryDealGetInteger(ticket,DEAL_TIME);
               GlobalVariableSet(Commom_gvp+pSymbol+"_HistStTm",pLoadHistoryFrom);
               FromI=i;
               break;
              }
           }
        }
      for(int i=FromI;i<HistoryDealsTotal();i++)
        {
         ulong ticket=HistoryDealGetTicket(i);
         if(ticket!=0)
           {
            if(HistoryDealGetString(ticket,DEAL_SYMBOL)==pSymbol)
              {
               long PosMagic=HistoryDealGetInteger(ticket,DEAL_MAGIC);
               if(PosMagic==pMagic || pMagic==-1)
                 {
                  switch(HistoryDealGetInteger(ticket,DEAL_TYPE))
                    {
                     case DEAL_TYPE_BUY:
                        pProfit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                        pLastTicket=ticket;
                        break;
                     case DEAL_TYPE_SELL:
                        pProfit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                        pLastTicket=ticket;
                        break;
                    }
                 }
              }
           }
        }
      pFirstStart=true;
     }
   if(!HistorySelect(pLoadHistoryFrom,TimeCurrent()))
     {
      return(false);
     }
   for(int i=HistoryDealsTotal()-1;i>=0;i--)
     {
      ulong ticket=HistoryDealGetTicket(i);
      if(ticket!=0)
        {
         if(ticket==pLastTicket)
           {
            break;
           }
         if(HistoryDealGetString(ticket,DEAL_SYMBOL)==pSymbol)
           {
            long PosMagic=HistoryDealGetInteger(ticket,DEAL_MAGIC);
            if(PosMagic==pMagic || pMagic==-1)
              {
               switch(HistoryDealGetInteger(ticket,DEAL_TYPE))
                 {
                  case DEAL_TYPE_BUY:
                     pProfit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                     break;
                  case DEAL_TYPE_SELL:
                     pProfit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                     break;
                 }
              }
           }
        }
     }
   if(HistoryDealsTotal()>0)
     {
      pLastTicket=HistoryDealGetTicket(HistoryDealsTotal()-1);
     }
//   pProfit=NormalizeDouble(pProfit,2);
   aProfit=pProfit;
   return(true);
  }
//+------------------------------------------------------------------+
